-
Prev | Orchestra Opcodes and Operators | Next

## -

- — Subtraction operator.

## Description

Arithmetic operators perform operations of change-sign (negate), don't-change-sign, logical AND logical OR, add, subtract, multiply and divide. Note that a value or an expression may fall between two of these operators, either of which could take it as its left or right argument, as in

a + b * c.

In such cases three rules apply:

1. * and / bind to their neighbors more strongly than + and −. Thus the above expression is taken as

a + (b * c)

with * taking b and c and then + taking a and b * c.

2. + and − bind more strongly than &&, which in turn is stronger than ||:

a && b - c || d

is taken as

(a && (b - c)) || d

3. When both operators bind equally strongly, the operations are done left to right:

a - b - c

is taken as

(a - b) - c

Parentheses may be used as above to force particular groupings.

## Syntax

    −a  (no rate restriction)

    a − b  (no rate restriction)

where the arguments a and b may be further expressions.

## Arguments

The arguments of − can be scalar values or k-rate one dimensional arrays (vectors), or any combination. If one of the arguments is an array, so is the value.

## Examples

Here is an example of the - operator. It uses the file subtracts.csd.

Example 25. Example of the - operator.

See the sections Real-time Audio and Command Line Flags for more information on using command line flags.

    <CsoundSynthesizer>
    <CsOptions>
    ; Select audio/midi flags here according to platform
    ; Audio out   Audio in    No messages
    -odac    ;;;realtime audio I/O
    ; For Non-realtime ouput leave only the line below:
    ; -o -.wav -W ;;; for file output any platform
    </CsOptions>
    <CsInstruments>

    sr = 44100
    ksmps = 32
    nchnls = 2
    0dbfs  = 1

    instr 1

    idur = p3
    iatt = p4
    idec = p5
    isus = p3-iatt-idec				;calculate sustain time from subtracting attack and decay
    printf_i "sutain time= note duration - attack - decay --> %.1f-%.1f-%.1f = %.1f\n", 1, idur, iatt, idec, isus

    kenv expseg 0.01, iatt, 1, isus, 1, idec, 0.01	;envelope
    asig poscil 1*kenv, 200, 1
         outs asig, asig

    endin
    </CsInstruments>
    <CsScore>
    f 1 0 4096 10 1	;sine wave
    ;      attack decay
    i 1 0 3 .1     .2
    i 1 4 3 .5    1.5
    i 1 8 5  4     .5

    e
    </CsScore>
    </CsoundSynthesizer>

Its output should include lines like these:

    sutain time= note duration - attack - decay --> 3.0-0.1-0.2 = 2.7
    sutain time= note duration - attack - decay --> 3.0-0.5-1.5 = 1.0
    sutain time= note duration - attack - decay --> 5.0-4.0-0.5 = 0.5

## See also

Arithmetic and Logic Operations

## Credits

Arithmetic on vectors is new in version 6.00

Prev | Up | Next
+ | Home | /